diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ClassChanger.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ClassChanger.java
new file mode 100644
index 0000000000..6140431876
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ClassChanger.java
@@ -0,0 +1,131 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update;
+
+import java.sql.SQLException;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+
+/**
+ * @author a.mueller
+ * @date 16.09.2010
+ *
+ */
+public class ClassChanger extends AuditedSchemaUpdaterStepBase<ClassChanger> implements ISchemaUpdaterStep {
+	private static final Logger logger = Logger.getLogger(ClassChanger.class);
+
+	private String newClassName;
+	private String[] oldClassNames;
+	private boolean isIdentifiable;
+	private boolean isAnnotatable;
+	private boolean isSourcable;
+
+	public static final ClassChanger NewIdentifiableInstance(String stepName, String tableName, String newClassNamePath, String[] oldClassNames, boolean includeAudTable){
+		return new ClassChanger(stepName, tableName, newClassNamePath, oldClassNames, includeAudTable, true, true, true);
+	}
+	public static final ClassChanger NewAnnotatableInstance(String stepName, String tableName, String newClassNamePath, String[] oldClassNames, boolean includeAudTable){
+		return new ClassChanger(stepName, tableName, newClassNamePath, oldClassNames, includeAudTable, true, false, false);
+	}
+	public static final ClassChanger NewDescriptionElementInstance(String stepName, String tableName, String newClassNamePath, String[] oldClassNames, boolean includeAudTable){
+		return new ClassChanger(stepName, tableName, newClassNamePath, oldClassNames, includeAudTable, true, true, false);
+	}
+	
+	
+	protected ClassChanger(String stepName, String tableName, String newClassName, String[] oldClassNames, boolean includeAudTable, boolean isAnnotatable, boolean isSourcable, boolean isIdentifiable) {
+		super(stepName);
+		this.tableName = tableName;
+		this.newClassName = newClassName;
+		this.oldClassNames = oldClassNames;
+		this.includeAudTable = includeAudTable;
+		this.isIdentifiable = isIdentifiable;
+		this.isAnnotatable = isAnnotatable;
+		this.isSourcable = isSourcable;
+	}
+
+	@Override
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
+		boolean result = true;
+		try {
+			if (true){
+				String updateQuery = getDtypeUpdateQueryString(tableName, datasource, monitor);
+				datasource.executeUpdate(updateQuery);
+			}
+			
+			if (isAnnotatable){
+				updateAnnotatables(tableName, datasource, monitor);
+			}
+			if (isSourcable){
+				updateSourcable(tableName, datasource, monitor);
+			}
+			
+			if (isIdentifiable){
+				updateIdentifiables(tableName, datasource, monitor);
+			}
+			
+			return result;
+		} catch ( Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.error(e);
+			return false;
+		}
+	}
+
+	private void updateSourcable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		updateSingleExtension("OriginalSourceBase", "sourcedObj_type" , datasource, monitor);
+	}
+	private void updateIdentifiables(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		updateSingleExtension("Extension", "extendedObj_type" , datasource, monitor);
+	}
+	private void updateAnnotatables(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		updateSingleExtension("Marker", "markedObj_type" , datasource, monitor);
+		updateSingleExtension("Annotation", "annotatedObj_type" , datasource, monitor);
+	}
+	private void updateSingleExtension(String extensionClass, String typeAttr, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException{
+		String sql = " UPDATE %s " +
+				" SET %s = '%s' " +
+				" WHERE %s = '%s'";
+		
+		for (String oldClassPath : oldClassNames){
+			String query = String.format(sql, extensionClass, 
+					typeAttr, newClassName, 
+					typeAttr, oldClassPath);
+			datasource.executeUpdate(query);
+		}
+	}
+
+	
+	public String getDtypeUpdateQueryString(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws DatabaseTypeNotSupportedException {
+		String updateQuery;
+		updateQuery = " UPDATE @tableName t " + 
+				" SET t.DTYPE = '@newTableName' " +
+				" WHERE (1=0 @dtypes)";
+		
+		updateQuery = updateQuery.replace("@tableName", tableName);
+		updateQuery = updateQuery.replace("@newTableName", getSimpleName(newClassName));
+		String dtypes = "";
+		for (String oldClassName : oldClassNames){
+			dtypes += String.format(" OR t.DTYPE = '%s' ", getSimpleName(oldClassName)) ;
+		}
+		updateQuery = updateQuery.replace("@dtypes", dtypes);
+		
+		return updateQuery;
+	}
+	private String getSimpleName(String className) {
+		String result = className;
+		while (result.contains(".")){
+			result = result.replaceAll(".*\\.", "");
+		}
+		return result;
+	}
+
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnAdder.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnAdder.java
index 29ed215962..9fc1bb0b92 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnAdder.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnAdder.java
@@ -9,8 +9,6 @@
 */
 package eu.etaxonomy.cdm.database.update;
 
-import java.sql.SQLException;
-
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
@@ -22,24 +20,31 @@ import eu.etaxonomy.cdm.database.ICdmDataSource;
  * @date 16.09.2010
  *
  */
-public class ColumnAdder extends SchemaUpdaterStepBase<ColumnAdder> implements ISchemaUpdaterStep {
+public class ColumnAdder extends AuditedSchemaUpdaterStepBase<ColumnAdder> implements ISchemaUpdaterStep {
 	private static final Logger logger = Logger.getLogger(ColumnAdder.class);
 	
-	private String tableName;
 	private String newColumnName;
 	private String columnType;
-	private boolean includeAudTable;
 	private Object defaultValue;
 	private boolean isNotNull;
+
 	private String referencedTable;
 
 	public static final ColumnAdder NewIntegerInstance(String stepName, String tableName, String newColumnName, boolean includeAudTable, boolean notNull, String referencedTable){
 		return new ColumnAdder(stepName, tableName, newColumnName, "int", includeAudTable, null, notNull, referencedTable);
 	}
 	
+	public static final ColumnAdder NewIntegerInstance(String stepName, String tableName, String newColumnName, boolean includeAudTable, Integer defaultValue, boolean notNull){
+		return new ColumnAdder(stepName, tableName, newColumnName, "int", includeAudTable, defaultValue, notNull, null);
+	}
+	
 	public static final ColumnAdder NewTinyIntegerInstance(String stepName, String tableName, String newColumnName, boolean includeAudTable, boolean notNull){
 		return new ColumnAdder(stepName, tableName, newColumnName, "tinyint", includeAudTable, null, notNull, null);
 	}
+	
+	public static final ColumnAdder NewDoubleInstance(String stepName, String tableName, String newColumnName, boolean includeAudTable, boolean notNull){
+		return new ColumnAdder(stepName, tableName, newColumnName, "double", includeAudTable, null, notNull, null);
+	}
 
 	public static final ColumnAdder NewBooleanInstance(String stepName, String tableName, String newColumnName, boolean includeAudTable, Boolean defaultValue){
 		return new ColumnAdder(stepName, tableName, newColumnName, "bit", includeAudTable, defaultValue, false, null);
@@ -52,6 +57,10 @@ public class ColumnAdder extends SchemaUpdaterStepBase<ColumnAdder> implements I
 	public static final ColumnAdder NewStringInstance(String stepName, String tableName, String newColumnName, int length, boolean includeAudTable){
 		return new ColumnAdder(stepName, tableName, newColumnName, "nvarchar("+length+")", includeAudTable, null, false, null);
 	}
+
+	public static final ColumnAdder NewClobInstance(String stepName, String tableName, String newColumnName, boolean includeAudTable){
+		return new ColumnAdder(stepName, tableName, newColumnName, "clob", includeAudTable, null, false, null);
+	}
 	
 	public static final ColumnAdder NewDateTimeInstance(String stepName, String tableName, String newColumnName, boolean includeAudTable){
 		return new ColumnAdder(stepName, tableName, newColumnName, "datetime", includeAudTable, null, false, null);
@@ -68,49 +77,32 @@ public class ColumnAdder extends SchemaUpdaterStepBase<ColumnAdder> implements I
 		this.referencedTable = referencedTable;
 	}
 
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
-	@Override
-	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
-		boolean result = true;
-		result &= addColumn(tableName, datasource, monitor);
-		if (includeAudTable){
-			String aud = "_AUD";
-			result &= addColumn(tableName + aud, datasource, monitor);
-		}
-		return (result == true )? 0 : null;
+	public ColumnAdder setNotNull(boolean isNotNull) {
+		this.isNotNull = isNotNull;
+		return this;
 	}
 
-	private boolean addColumn(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
+	@Override
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
 		boolean result = true;
 		try {
 			String updateQuery = getUpdateQueryString(tableName, datasource, monitor);
-			try {
-				datasource.executeUpdate(updateQuery);
-			} catch (SQLException e) {
-				logger.error(e);
-				result = false;
-			}
+			datasource.executeUpdate(updateQuery);
 			
 			if (defaultValue instanceof Boolean){
 				updateQuery = "UPDATE @tableName SET @columnName = " + (defaultValue == null ? "null" : getBoolean((Boolean) defaultValue, datasource));
 				updateQuery = updateQuery.replace("@tableName", tableName);
 				updateQuery = updateQuery.replace("@columnName", newColumnName);
-				try {
-					datasource.executeUpdate(updateQuery);
-				} catch (SQLException e) {
-					logger.error(e);
-					result = false;
-				}
+				datasource.executeUpdate(updateQuery);
 			}
 			if (referencedTable != null){
-				result &= TableCreator.makeForeignKey(tableName, datasource, newColumnName, referencedTable);
+				result &= TableCreator.makeForeignKey(tableName, datasource, monitor, newColumnName, referencedTable);
 			}
 			
 			return result;
-		} catch ( DatabaseTypeNotSupportedException e) {
+		} catch ( Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.error(e);
 			return false;
 		}
 	}
@@ -142,15 +134,36 @@ public class ColumnAdder extends SchemaUpdaterStepBase<ColumnAdder> implements I
 		return updateQuery;
 	}
 
-	private String getDatabaseColumnType(ICdmDataSource datasource, String columnType) {
+	protected static String getDatabaseColumnType(ICdmDataSource datasource, String columnType) {
 		String result = columnType;
-		if (datasource.getDatabaseType().equals(DatabaseTypeEnum.PostgreSQL)){
+		DatabaseTypeEnum dbType = datasource.getDatabaseType();
+		//nvarchar
+		if (dbType.equals(DatabaseTypeEnum.PostgreSQL)){
 			result = result.replace("nvarchar", "varchar");
 		}
+		//CLOB
+		if (columnType.equalsIgnoreCase("clob")){
+			//TODO use hibernate dialects
+			if (dbType.equals(DatabaseTypeEnum.MySQL)){
+				result = "longtext";
+			}else if (dbType.equals(DatabaseTypeEnum.H2)){
+				result = "CLOB";  //or NVARCHAR
+			}else if (dbType.equals(DatabaseTypeEnum.PostgreSQL)){
+				result = "text";
+			}else if (dbType.equals(DatabaseTypeEnum.SqlServer2005)){
+				result = "NVARCHAR(MAX)";
+			}
+		}
 		return result;
 	}
 	
 
+	/**
+	 * Returns the sql keywords for adding a column. This is usually 'ADD' or 'ADD COLUMN'
+	 * @param datasource
+	 * @return
+	 * @throws DatabaseTypeNotSupportedException
+	 */
 	public static String getAddColumnSeperator(ICdmDataSource datasource) throws DatabaseTypeNotSupportedException {
 		DatabaseTypeEnum type = datasource.getDatabaseType();
 		if (type.equals(DatabaseTypeEnum.SqlServer2005)){
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnNameChanger.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnNameChanger.java
index ee4e96a5a2..761a508dbd 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnNameChanger.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnNameChanger.java
@@ -9,8 +9,6 @@
 */
 package eu.etaxonomy.cdm.database.update;
 
-import java.sql.SQLException;
-
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
@@ -22,81 +20,79 @@ import eu.etaxonomy.cdm.database.ICdmDataSource;
  * @date 16.09.2010
  *
  */
-public class ColumnNameChanger extends SchemaUpdaterStepBase<ColumnNameChanger> implements ISchemaUpdaterStep {
+public class ColumnNameChanger extends AuditedSchemaUpdaterStepBase<ColumnNameChanger> implements ISchemaUpdaterStep {
 	private static final Logger logger = Logger.getLogger(ColumnNameChanger.class);
 	
-	private String tableName;
 	private String newColumnName;
 	private String oldColumnName;
-	private boolean includeAudTable;
-	private boolean isInteger; //TODO make enum
+	private Datatype datatype; //TODO make enum
+	
+	private enum Datatype{
+		integer,
+		clob
+	}
 	
 	public static ColumnNameChanger NewIntegerInstance(String stepName, String tableName, String oldColumnName, String newColumnName, boolean includeAudTable){
-		return new ColumnNameChanger(stepName, tableName, oldColumnName, newColumnName, includeAudTable, null, true);
+		return new ColumnNameChanger(stepName, tableName, oldColumnName, newColumnName, includeAudTable, null, Datatype.integer);
+	}
+	
+	public static ColumnNameChanger NewClobInstance(String stepName, String tableName, String oldColumnName, String newColumnName, boolean includeAudTable){
+		return new ColumnNameChanger(stepName, tableName, oldColumnName, newColumnName, includeAudTable, null, Datatype.clob);
 	}
 
-	protected ColumnNameChanger(String stepName, String tableName, String oldColumnName, String newColumnName, boolean includeAudTable, Object defaultValue, boolean isInteger) {
+	protected ColumnNameChanger(String stepName, String tableName, String oldColumnName, String newColumnName, boolean includeAudTable, Object defaultValue, Datatype datatype) {
 		super(stepName);
 		this.tableName = tableName;
 		this.newColumnName = newColumnName;
 		this.oldColumnName = oldColumnName;
 		this.includeAudTable = includeAudTable;
-		this.isInteger = isInteger;
-	}
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
-	@Override
-	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
-		boolean result = true;
-		result &= changeColumnName(tableName, datasource, monitor);
-		if (includeAudTable){
-			String aud = "_AUD";
-			result &= changeColumnName(tableName + aud, datasource, monitor);
-		}
-		return (result == true )? 0 : null;
+		this.datatype = datatype;
 	}
 
-	private boolean changeColumnName(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
-		boolean result = true;
-		DatabaseTypeEnum type = datasource.getDatabaseType();
-		String updateQuery;
-		
-		
-		if (type.equals(DatabaseTypeEnum.SqlServer2005)){
-			logger.warn("SQLServer column name changer syntax not yet tested");
-			updateQuery = "EXEC sp_rename '@oldName', '@newName'";
-		}else if (type.equals(DatabaseTypeEnum.H2)){
-			updateQuery = "ALTER TABLE @tableName ALTER COLUMN @oldColumnName RENAME TO @newColumnName";
-		}else if ( type.equals(DatabaseTypeEnum.MySQL)){
-			//FIXME MySQL column name changer
-//			logger.warn("Changing column name not yet supported for MySQL");
-			updateQuery = "ALTER TABLE @tableName CHANGE COLUMN @oldColumnName @newColumnName @definition";
-		}else if ( type.equals(DatabaseTypeEnum.PostgreSQL) ){
-			updateQuery = "ALTER TABLE @tableName RENAME COLUMN @oldColumnName TO @newColumnName;";
-		}else{
-			updateQuery = null;
-			monitor.warning("Update step '" + this.getStepName() + "' is not supported by " + type.getName());
-			return false;
-		}
-		updateQuery = updateQuery.replace("@tableName", tableName);
-		updateQuery = updateQuery.replace("@oldColumnName", oldColumnName);
-		updateQuery = updateQuery.replace("@newColumnName", newColumnName);
-		updateQuery = updateQuery.replace("@definition", getDefinition());
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
 		try {
+			boolean result = true;
+			DatabaseTypeEnum type = datasource.getDatabaseType();
+			String updateQuery;
+			
+			
+			if (type.equals(DatabaseTypeEnum.SqlServer2005)){
+				logger.warn("SQLServer column name changer syntax not yet tested");
+				updateQuery = "EXEC sp_rename '@oldName', '@newName'";
+			}else if (type.equals(DatabaseTypeEnum.H2)){
+				updateQuery = "ALTER TABLE @tableName ALTER COLUMN @oldColumnName RENAME TO @newColumnName";
+			}else if ( type.equals(DatabaseTypeEnum.MySQL)){
+				//FIXME MySQL column name changer
+//			logger.warn("Changing column name not yet supported for MySQL");
+				updateQuery = "ALTER TABLE @tableName CHANGE COLUMN @oldColumnName @newColumnName @definition";
+			}else if ( type.equals(DatabaseTypeEnum.PostgreSQL) ){
+				updateQuery = "ALTER TABLE @tableName RENAME COLUMN @oldColumnName TO @newColumnName;";
+			}else{
+				updateQuery = null;
+				monitor.warning("Update step '" + this.getStepName() + "' is not supported by " + type.getName());
+				return false;
+			}
+			updateQuery = updateQuery.replace("@tableName", tableName);
+			updateQuery = updateQuery.replace("@oldColumnName", oldColumnName);
+			updateQuery = updateQuery.replace("@newColumnName", newColumnName);
+			updateQuery = updateQuery.replace("@definition", getDefinition());
 			datasource.executeUpdate(updateQuery);
-		} catch (SQLException e) {
+			
+			return result;
+		} catch (Exception e) {
+			monitor.warning(e.getMessage(), e);
 			logger.error(e);
-			result = false;
+			return false;
 		}
-
-		return result;
 	}
 
+
+	//TODO use same code as ColumnTypeChanger or ColumnAdder
 	private CharSequence getDefinition() {
-		if (isInteger){
+		if (this.datatype == Datatype.integer){
 			return "integer";
+		}else if (this.datatype == Datatype.clob){
+			return "longtext";
 		}else{
 			throw new RuntimeException("Definition type not supported");
 		}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnRemover.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnRemover.java
index 4a4ad662a2..ae139846e2 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnRemover.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnRemover.java
@@ -9,8 +9,6 @@
 */
 package eu.etaxonomy.cdm.database.update;
 
-import java.sql.SQLException;
-
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
@@ -22,13 +20,10 @@ import eu.etaxonomy.cdm.database.ICdmDataSource;
  * @date 16.09.2010
  *
  */
-public class ColumnRemover extends SchemaUpdaterStepBase<ColumnRemover> implements ISchemaUpdaterStep {
-	@SuppressWarnings("unused")
+public class ColumnRemover extends AuditedSchemaUpdaterStepBase<ColumnRemover> implements ISchemaUpdaterStep {
 	private static final Logger logger = Logger.getLogger(ColumnRemover.class);
 	
-	private String tableName;
 	private String oldColumnName;
-	private boolean includeAudTable;
 	
 	public static final ColumnRemover NewInstance(String stepName, String tableName, String oldColumnName, boolean includeAudTable){
 		return new ColumnRemover(stepName, tableName, oldColumnName, includeAudTable);
@@ -42,32 +37,16 @@ public class ColumnRemover extends SchemaUpdaterStepBase<ColumnRemover> implemen
 		this.includeAudTable = includeAudTable;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
 	@Override
-	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
-		boolean result = true;
-		result &= removeColumn(tableName, datasource, monitor);
-		if (includeAudTable){
-			String aud = "_AUD";
-			result &= removeColumn(tableName + aud, datasource, monitor);
-		}
-		return (result == true )? 0 : null;
-	}
-
-	private boolean removeColumn(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
 		boolean result = true;
 		try {
 			String updateQuery = getUpdateQueryString(tableName, datasource, monitor);
-			try {
-				datasource.executeUpdate(updateQuery);
-			} catch (SQLException e) {
-				logger.error(e);
-				result = false;
-			}
+			datasource.executeUpdate(updateQuery);
 			return result;
-		} catch ( DatabaseTypeNotSupportedException e) {
+		} catch ( Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.error(e);
 			return false;
 		}
 	}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnTypeChanger.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnTypeChanger.java
new file mode 100644
index 0000000000..d546648daa
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ColumnTypeChanger.java
@@ -0,0 +1,148 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.DatabaseTypeEnum;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+
+/**
+ * @author a.mueller
+ * @date 16.09.2010
+ *
+ */
+public class ColumnTypeChanger extends AuditedSchemaUpdaterStepBase<ColumnTypeChanger> implements ISchemaUpdaterStep {
+	private static final Logger logger = Logger.getLogger(ColumnTypeChanger.class);
+	
+	private String columnName;
+	private String newColumnType;
+	private Object defaultValue;
+	private boolean isNotNull;
+	private String referencedTable;
+
+
+	public static final ColumnTypeChanger NewStringSizeInstance(String stepName, String tableName, String columnName, int newSize, boolean includeAudTable){
+		return new ColumnTypeChanger(stepName, tableName, columnName, "nvarchar("+newSize+")", includeAudTable, null, false, null);
+	}
+	
+	public static final ColumnTypeChanger NewClobInstance(String stepName, String tableName, String columnName, boolean includeAudTable){
+		return new ColumnTypeChanger(stepName, tableName, columnName, "clob", includeAudTable, null, false, null);
+	}
+	
+	public static final ColumnTypeChanger NewInt2DoubleInstance(String stepName, String tableName, String columnName, boolean includeAudTable){
+		return new ColumnTypeChanger(stepName, tableName, columnName, "double", includeAudTable, null, false, null);
+	}
+
+	public static final ColumnTypeChanger NewInt2StringInstance(String stepName, String tableName, String columnName, int size, boolean includeAudTable, Integer defaultValue, boolean notNull){
+		return new ColumnTypeChanger(stepName, tableName, columnName, "nvarchar("+size+")", includeAudTable, defaultValue, notNull, null);
+	}
+	
+	
+	protected ColumnTypeChanger(String stepName, String tableName, String columnName, String newColumnType, boolean includeAudTable, Object defaultValue, boolean notNull, String referencedTable) {
+		super(stepName);
+		this.tableName = tableName;
+		this.columnName = columnName;
+		this.newColumnType = newColumnType;
+		this.includeAudTable = includeAudTable;
+		this.defaultValue = defaultValue;
+		this.isNotNull = notNull;
+		this.referencedTable = referencedTable;
+	}
+
+	@Override
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
+		boolean result = true;
+		try {
+			
+			String updateQuery;
+			if (this.isNotNull){
+				updateQuery = getNotNullUpdateQuery(tableName, datasource, monitor);
+				datasource.executeUpdate(updateQuery);
+			}
+			
+			updateQuery = getUpdateQueryString(tableName, datasource, monitor);
+			datasource.executeUpdate(updateQuery);
+			
+			if (defaultValue instanceof Boolean){
+				updateQuery = "UPDATE @tableName SET @columnName = " + (defaultValue == null ? "null" : getBoolean((Boolean) defaultValue, datasource));
+				updateQuery = updateQuery.replace("@tableName", tableName);
+				updateQuery = updateQuery.replace("@columnName", columnName);
+				datasource.executeUpdate(updateQuery);
+			}
+			if (referencedTable != null){
+				result &= TableCreator.makeForeignKey(tableName, datasource, monitor, columnName, referencedTable);
+			}
+				
+			return result;
+		} catch ( Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.error(e);
+			return false;
+		}
+	}
+
+	private String getNotNullUpdateQuery(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
+		String query = " UPDATE %s SET %s = %S WHERE %s IS NULL ";
+		String defaultValueStr = String.valueOf(this.defaultValue);
+		if (this.defaultValue instanceof Integer){
+			//OK
+		}else{
+			defaultValueStr = "'" + defaultValueStr + "'";
+		}
+		query = String.format(query, tableName, this.columnName, defaultValueStr, this.columnName);
+		return query;
+	}
+
+	public String getUpdateQueryString(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws DatabaseTypeNotSupportedException {
+		String updateQuery;
+		DatabaseTypeEnum type = datasource.getDatabaseType();
+		String databaseColumnType = getDatabaseColumnType(datasource, this.newColumnType);
+
+		if (type.equals(DatabaseTypeEnum.SqlServer2005)){
+			//MySQL allows both syntaxes
+			updateQuery = "ALTER TABLE @tableName ALTER COLUMN @columnName @columnType";
+		}else if (type.equals(DatabaseTypeEnum.H2)){
+			updateQuery = "ALTER TABLE @tableName ALTER COLUMN @columnName @columnType";
+		}else if (type.equals(DatabaseTypeEnum.PostgreSQL)){
+			updateQuery = "ALTER TABLE @tableName ALTER COLUMN @columnName TYPE @columnType";
+		}else if (type.equals(DatabaseTypeEnum.MySQL)){
+			updateQuery = "ALTER TABLE @tableName MODIFY COLUMN @columnName @columnType";
+		}else{
+			updateQuery = null;
+			String warning = "Update step '" + this.getStepName() + "' is not supported by " + type.getName();
+			monitor.warning(warning);
+			throw new DatabaseTypeNotSupportedException(warning);
+		}
+		if (isNotNull){
+			updateQuery += " NOT NULL";
+		}
+		updateQuery = updateQuery.replace("@tableName", tableName);
+		updateQuery = updateQuery.replace("@columnName", columnName);
+		updateQuery = updateQuery.replace("@columnType", databaseColumnType);
+//		updateQuery = updateQuery.replace("@addSeparator", getAddColumnSeperator(datasource));
+		
+		return updateQuery;
+	}
+
+	private String getDatabaseColumnType(ICdmDataSource datasource, String columnType) {
+		return ColumnAdder.getDatabaseColumnType(datasource, columnType);
+	}
+	
+	public String getReferencedTable() {
+		return referencedTable;
+	}
+//
+//	public String getNewColumnName() {
+//		return columnName;
+//	}
+
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ISchemaUpdaterStep.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ISchemaUpdaterStep.java
index daa0578d22..80703bffe2 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ISchemaUpdaterStep.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/ISchemaUpdaterStep.java
@@ -23,4 +23,8 @@ public interface ISchemaUpdaterStep {
 
 	public List<ISchemaUpdaterStep> getInnerSteps();
 
+	public boolean isIgnoreErrors();
+
+	public void setIgnoreErrors(boolean ignoreErrors);
+
 }
\ No newline at end of file
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/MapTableCreator.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/MapTableCreator.java
index 57e0a696af..834c4c30cb 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/MapTableCreator.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/MapTableCreator.java
@@ -26,7 +26,7 @@ public class MapTableCreator extends TableCreator {
 
 	
 	protected MapTableCreator(String stepName, String firstTableName, String firstTableAlias, String secondTableName, String secondTableAlias, String mapKeyTableName, boolean includeAudTable) {
-		super(stepName, firstTableName + "_" + secondTableName, new ArrayList<String>(), new ArrayList<String>(), new ArrayList<Object>(), new ArrayList<Boolean>(), new ArrayList<String>(), includeAudTable, false, false);
+		super(stepName, firstTableName + "_" + secondTableName, new ArrayList<String>(), new ArrayList<String>(), new ArrayList<Object>(), new ArrayList<Boolean>(), new ArrayList<String>(), includeAudTable, false, false, false);
 		this.firstTableName = firstTableName;
 		this.secondTableName = secondTableName;
 		this.firstTableAlias = (firstTableAlias != null )? firstTableAlias : firstTableName ;
